package aokai.app.BMSPayer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteCursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnCompletionListener;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.VideoView;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.SurfaceView;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;

public class Main extends Activity implements OnCompletionListener{
	public String state = Environment.getExternalStorageState();
	// get file path
	String filepath = Environment.getExternalStorageDirectory().toString();
	File newfile = new File(filepath + "/BMSPlayer/music");
	ArrayAdapter<String> arrayAdapter;
	public ListView listView;
	public static Read_HEADERFile bms = new Read_HEADERFile();
	private DatabaseOpenHelper dbHelpar;
	private SQLiteDatabase db;
	private Main_view mainv;
	private long start;
	ProgressDialog dialog;
	private int topPosition;
	private int topPositionY;
	public static int temphightscore = 0;
	public Bitmap numbars;
	public Bitmap[][] def_numbar = new Bitmap[5][10];
	public Bitmap[] titelbar = new Bitmap[6];
	public VideoView video;
	public SurfaceView sv;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// タイトルバーを非表示にする
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		//縦固定;
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		setContentView(R.layout.main);
		numbars = BitmapFactory.decodeResource(getResources(),
				R.drawable.def_number);
		for (int i = 0; i < 5; i++) {
			for (int j = 0; j < 10; j++) {
				def_numbar[i][j] = Bitmap.createBitmap(numbars, j * 16, i * 14,
						16, 14);
			}
		}
		for (int i = 0; i < 6; i++) {
			titelbar[i] = Bitmap.createBitmap(BitmapFactory.decodeResource(
					getResources(), R.drawable.titelbar), 0, i * 28, 320, 28);
		}
		listView = (ListView) findViewById(R.id.listview);
		if (state.equals(Environment.MEDIA_SHARED)) {
			D_finish();
		}
		// データーベースオブジェクトの取得
		dbHelpar = new DatabaseOpenHelper(this);
		db = dbHelpar.getWritableDatabase();
		// リストビューのアイテムがクリックされた時に呼び出されるコールバックリスナーを登録します
		listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
			}
		});
		sv = (SurfaceView) findViewById(R.id.SurfaceView01);
		mainv = new Main_view(this, sv);
		make_folder();
		show_header_list_sort();
		video = (VideoView) findViewById(R.id.videoView1);	
		video.setVideoPath("android.resource://aokai.app.BMSPayer/" + R.raw.aaaf);
		video.setOnCompletionListener(this);
		video.requestFocus();	
		video.start();
	}
	@Override
	public void onCompletion(MediaPlayer mp) {
		mp.seekTo(0);
		mp.start();
	}


	

	public void show_folder_list() {
		String[] files = newfile.list();
		arrayAdapter = new ArrayAdapter<String>(this, R.layout.list_style,
				files);
		listView.setAdapter(arrayAdapter);
	}

	public void make_database() {
		start = System.currentTimeMillis();
		ContentValues values = new ContentValues();
		values.put("ONOFF", 0);
		db.update("music_List", values,null,null);
		Search_file(filepath + "/BMSPlayer/music");
	}

	// ファイルの中身を表示
	public void show_bms_file(String path) {
		start = System.currentTimeMillis();
		arrayAdapter = new ArrayAdapter<String>(this, R.layout.list_style);
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(
					new FileInputStream(path), "Shift_JIS"));
			String line;
			start = System.currentTimeMillis();
			while ((line = br.readLine()) != null) {
				arrayAdapter.add(line);
			}
			start = System.currentTimeMillis() - start;
		} catch (IOException e) {
			System.out.println(e);
		}
		arrayAdapter.add("読み込み処理時間  = " + start);
		listView.setAdapter(arrayAdapter);
	}

	// 再帰で始めに渡したpathより深い所にあるbmsファイルを探し出す
	public void Search_file(String path) {
		File nowfile = new File(path);
		String[] files = nowfile.list();
		for (int i = 0; i < files.length; i++) {
			if (files[i].indexOf(".") != -1) {
				if (files[i].indexOf(".bms") != -1) {
					// arrayAdapter.add(path + "/" + files[i]);
					bms = new Read_HEADERFile();
					bms.Read_header(path, files[i].toString());
					srachDB(bms);
				}
				if (files[i].indexOf(".bme") != -1) {
					// arrayAdapter.add(path + "/" + files[i]);
					bms = new Read_HEADERFile();
					bms.Read_header(path, files[i].toString());
					srachDB(bms);
				}
				if (files[i].indexOf(".bml") != -1) {
					// arrayAdapter.add(path + "/" + files[i]);
					bms = new Read_HEADERFile();
					bms.Read_header(path, files[i].toString());
					srachDB(bms);
				}
			} else {
				Search_file(path + "/" + files[i]);
			}
		}
	}

	private void srachDB(Read_HEADERFile header) {
		String where = "file_path=? AND file_name=? AND PLAYLEVEL=?";
		String[] id = { header.file_path, header.file_name,
				"" + header.PLAYLEVEL };
		Cursor c = db.query("music_List", new String[] { "file_name" }, where,
				id, null, null, null, "10");
		if (c.getCount() == 0) {
			dbHelpar.writeDB(db, header);
		}else{
			ContentValues values = new ContentValues();
			values.put("ONOFF", 1);
			String[] ids = {header.file_name,
					"" + header.PLAYLEVEL };
			db.update("music_List", values,
					"file_name=? AND PLAYLEVEL=?",
					ids);
		}
	}

	// bmsファイルを渡すとそのヘッダをlistviewで表示する
	public void show_bms_header(Read_HEADERFile bms) {
		start = System.currentTimeMillis();
		arrayAdapter = new ArrayAdapter<String>(this, R.layout.list_style);
		String line = "";
		switch (bms.File_Format) {
		case 1:
			line = "bms";
			break;
		case 2:
			line = "bme";
			break;
		case 3:
			line = "bml";
			break;
		}
		arrayAdapter.add("ファイル形式 = " + line);
		arrayAdapter.add("path = " + bms.file_path);
		arrayAdapter.add("fileName = " + bms.file_name);
		arrayAdapter.add("PLAYER = " + bms.PLAYER);
		arrayAdapter.add("GENRE = " + bms.GENRE);
		arrayAdapter.add("TITLE = " + bms.TITLE);
		arrayAdapter.add("SUBTITLE = " + bms.SUBTITLE);
		arrayAdapter.add("ARTIST = " + bms.ARTIST);
		arrayAdapter.add("BPM = " + bms.BPM);
		arrayAdapter.add("PLAYLEVEL = " + bms.PLAYLEVEL);
		arrayAdapter.add("LNTYPE = " + bms.LNTYPE);
		arrayAdapter.add("LNOBJ = " + bms.LNOBJ);
		arrayAdapter.add("RANK = " + bms.RANK);
		arrayAdapter.add("TOTAL = " + bms.TOTAL);
		arrayAdapter.add("DIFFICULTY = " + bms.DIFFICULTY);
		arrayAdapter.add("STAGEFILE = " + bms.STAGEFILE);
		start = System.currentTimeMillis() - start;
		arrayAdapter.add("読み込み処理時間  = " + start);
		listView.setAdapter(arrayAdapter);
	}

	// 曲リストをソートして表示
	public void show_header_list_sort() {
		List<Read_HEADERFile> list = new ArrayList<Read_HEADERFile>();
		String sql = "select * from " + "music_List " + "order by "
				+ "PLAYLEVEL asc" + ";";
		try {
			SQLiteCursor c = (SQLiteCursor) db.rawQuery(sql, null);

			int rowcount = c.getCount();
			c.moveToFirst();

			for (int i = 0; i < rowcount; i++) {
				Read_HEADERFile temp_rh;
				temp_rh = dbHelpar.getRead_HEADER(c);
				if(temp_rh !=null){
					list.add(temp_rh);
				}
				c.moveToNext();
			}
		} catch (SQLException e) {
		}

		ListAdapter adapter = new ListAdapter(getApplicationContext(), list);
		listView.setAdapter(adapter);
	}

	// 曲リストを表示
	public void show_header_list() {
		List<Read_HEADERFile> list = new ArrayList<Read_HEADERFile>();
		String sql = "select * from " + "music_List" + ";";

		try {
			SQLiteCursor c = (SQLiteCursor) db.rawQuery(sql, null);

			int rowcount = c.getCount();
			c.moveToFirst();

			for (int i = 0; i < rowcount; i++) {
				list.add(dbHelpar.getRead_HEADER(c));

				c.moveToNext();
			}
		} catch (SQLException e) {
		}

		ListAdapter adapter = new ListAdapter(getApplicationContext(), list);
		listView.setAdapter(adapter);

		/******************** SimpleAdapterをつかった方法 ********************/
		// List<HashMap<String, Object>> myData = new ArrayList<HashMap<String,
		// Object>>();
		// Map<String, Object> map;
		// Read_HEADER bms;
		// String sql = "select * from " + "music_List;";
		// try {
		// SQLiteCursor c = (SQLiteCursor) db.rawQuery(sql, null);
		// int rowcount = c.getCount();
		// c.moveToFirst();
		//
		// for (int i = 0; i < rowcount; i++) {
		// bms = dbHelpar.getRead_HEADER(c);
		// map = new HashMap<String, Object>();
		// map.put("TITLE", bms.TITLE);
		// map.put("PLAYLEVEL", bms.PLAYLEVEL);
		// map.put("ARTIST", bms.ARTIST);
		// map.put("GENRE", bms.GENRE);
		// map.put("file_path", bms.file_path);
		// map.put("DIFFICULTY", bms.difficultColor());
		// myData.add((HashMap<String, Object>) map);
		//
		// c.moveToNext();
		// }
		// } catch (SQLException e) {
		// Log.e("ERROR", e.toString());
		// }
		// String[] from = { "TITLE", "PLAYLEVEL", "ARTIST", "GENRE" };
		// SimpleAdapter adapter = new SimpleAdapter(this, myData,
		// R.layout.bmslist_style, from, new int[] { R.id.title,
		// R.id.level, R.id.artist, R.id.ganle });
		// listView.setAdapter(adapter);
	}

	public void make_folder() {
		if (newfile.mkdir()) {
			Toast toast = Toast.makeText(this, "ディレクトリの作成に成功しました",
					Toast.LENGTH_SHORT);
			toast.show();
		} else {
		}
	}

	public void D_finish() {
		AlertDialog.Builder dialog = new AlertDialog.Builder(this);
		dialog.setMessage("PCに接続されているためファイルが読み込めません");
		dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
				finish();
			}
		});
		dialog.show();
	}

	private class ListAdapter extends ArrayAdapter<Read_HEADERFile> {
		private LayoutInflater mInflater;
		public TextView Title;
		public ImageView level1;
		public ImageView level2;
		public LinearLayout layout;
		public ImageView titleBar;

		public ListAdapter(Context context, List<Read_HEADERFile> objects) {
			super(context, 0, objects);
			mInflater = (LayoutInflater) context
					.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		}

		private void intent(Read_HEADERFile All_bms) {
			// スクロールの位置を保存
			topPosition = listView.getFirstVisiblePosition();
			topPositionY = listView.getChildAt(0).getTop();
			Intent intent = new Intent(Main.this, Game_test.class);
			intent.putExtra("Read_HEADERFile", All_bms);
			intent.setAction(Intent.ACTION_VIEW);
			startActivity(intent);
		}

		public View getView(final int position, View convertView,
				ViewGroup parent) {
			if (convertView == null) {
				convertView = mInflater.inflate(R.layout.bmslist_style, null);
			}
			final Read_HEADERFile item = this.getItem(position);
			if (item != null) {
				Title = (TextView) convertView.findViewById(R.id.title);
				level1 = (ImageView) convertView.findViewById(R.id.Imagelevel1);
				level2 = (ImageView) convertView.findViewById(R.id.Imagelevel2);
				layout = (LinearLayout) convertView.findViewById(R.id.layout);
				titleBar = (ImageView) convertView.findViewById(R.id.titlebar);
				titleBar.setImageBitmap(titelbar[item.CLEAR]);
				Title.setText(item.TITLE + item.SUBTITLE);
				if (item.PLAYLEVEL / 10 != 0) {
					level1.setImageBitmap(def_numbar[item.DIFFICULTY - 1][item.PLAYLEVEL / 10]);
				} else {
					level1.setImageBitmap(Bitmap.createBitmap(16, 14,
							Bitmap.Config.ARGB_8888));
				}
				level2.setImageBitmap(def_numbar[item.DIFFICULTY - 1][item.PLAYLEVEL % 10]);
				layout.setOnClickListener(new OnClickListener() {
					@Override
					public void onClick(View v) {
						if (Main.bms == item) {
							topPosition = listView.getFirstVisiblePosition();
							topPositionY = listView.getChildAt(0).getTop();
							Read_BMSFile All_bms = new Read_BMSFile();
							All_bms.Read(item.file_path, item.file_name);

							intent(item);
							// show_bms_header(item);
						} else {
							Main.bms = item;
							mainv.set_Read_HEADERFile(item);
							mainv.draw();
						}
					}
				});
			}
			return convertView;
		}
	}

	private class Progress implements Runnable {

		public void run() {
			make_database();

			// -----[読み込み終了の通知]
			handler.sendEmptyMessage(0);
		}
	}

	private Handler handler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			// -----[ダイアログを閉じる]
			dialog.dismiss();
			show_header_list_sort();
		}
	};

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.settings:
			Intent intent = new Intent(Main.this, Preferences.class);
			startActivity(intent);
			return true;
		case R.id.reload:
			dialog = new ProgressDialog(Main.this);
			// dialog.setTitle("");
			dialog.setMessage("Now Loading...");
			dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
			dialog.show();

			// -----[ローディングの描画は別スレッドで行う]
			Thread thread = new Thread(new Progress());
			thread.start();
			// show_file_list();
			return true;
		}
		return false;
	}

	@Override
	public void onPause(){
		super.onPause();
		video.stopPlayback();
	}
	// アプリの再開
	@Override
	public void onResume() {
		super.onResume();	
		video.start();
		//横固定
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		//縦固定;
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		db = dbHelpar.getWritableDatabase();
		show_header_list_sort();
		if (bms.HIGHTSCORE < temphightscore) {
			bms.HIGHTSCORE = temphightscore;
			mainv.draw();
		}
		listView.setSelectionFromTop(topPosition, topPositionY);
	}
}