package aokai.app.BMSPayer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PorterDuff;
import android.graphics.PixelFormat;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class Main_view implements SurfaceHolder.Callback {
	private SurfaceHolder holder;
	private Context context;
	private Read_HEADERFile bms;
	private Bitmap Back;
	private Bitmap[] numbar = new Bitmap[11];
	private Bitmap[] clear = new Bitmap[6];
	private Bitmap[] ABCD = new Bitmap[6];

	public Main_view(Context main, SurfaceView sv) {
		// SurfaceViewからholderを取得し、インターフェイスを設定する。
		context = main;
		holder = sv.getHolder();
		holder.addCallback(this);
		sv.getHolder().setFormat(PixelFormat.TRANSPARENT);
		for (int i = 0; i < 11; i++) {
			numbar[i] = Bitmap.createBitmap(BitmapFactory.decodeResource(
					context.getResources(), R.drawable.score_num), i * 8, 0, 8,
					8);
		}
		for (int i = 0; i < 6; i++) {
			clear[i] = Bitmap.createBitmap(BitmapFactory.decodeResource(
					context.getResources(), R.drawable.clear), 0, i * 10, 72,
					10);
		}
		for (int i = 0; i < 2; i++) {
			for (int j = 0; j < 3; j++) {
				ABCD[i * 3 + j] = Bitmap.createBitmap(BitmapFactory
						.decodeResource(context.getResources(),
								R.drawable.abcdef), j * 21, i * 24, 21, 24);
			}
		}
		bms = new Read_HEADERFile();
		bms.TITLE = "SELECT MUSIC";
		Back = BitmapFactory.decodeResource(context.getResources(),
				R.drawable.m_back);
	}

	public void draw() {
		Canvas canvas = holder.lockCanvas();
		canvas.drawColor(0,PorterDuff.Mode.CLEAR ); 
		Paint paint = new Paint();
		Boolean temp_flag = true;
		// グラフの描写
		paint.setAntiAlias(true);
		paint.setStrokeWidth(2.0f);
		paint.setColor(Color.GRAY);
		canvas.drawRect(20, 198, 151,
				203, paint);
		if (bms.Max_Noat != 0) {
			paint.setColor(Color.rgb(110, 202, 234));
			canvas.drawRect(20, 198, 20 + 131 * bms.HIGHTSCORE / (bms.Max_Noat*2),
					203, paint);
		}
		canvas.drawBitmap(Back, 0, 0, null);
		// EXSCOREの描写
		if (bms.HIGHTSCORE % 10000 / 1000 == 0 && temp_flag) {
			canvas.drawBitmap(numbar[10], 60, 166, null);

		} else {
			canvas.drawBitmap(numbar[bms.HIGHTSCORE % 10000 / 1000], 60, 166,
					null);
			temp_flag = false;
		}
		if (bms.HIGHTSCORE % 1000 / 100 == 0 && temp_flag) {
			canvas.drawBitmap(numbar[10], 68, 166, null);
		} else {
			canvas.drawBitmap(numbar[bms.HIGHTSCORE % 1000 / 100], 68, 166,
					null);
			temp_flag = false;
		}
		if (bms.HIGHTSCORE % 100 / 10 == 0 && temp_flag) {
			canvas.drawBitmap(numbar[10], 76, 166, null);
		} else {
			canvas.drawBitmap(numbar[bms.HIGHTSCORE % 100 / 10], 76, 166, null);
			temp_flag = false;
		}
		canvas.drawBitmap(numbar[bms.HIGHTSCORE % 10], 84, 166, null);
		// ミスカウントの描写
		if (bms.MISS != -1) {
			temp_flag =true;
			if (bms.MISS % 10000 / 1000 == 0 && temp_flag) {
				canvas.drawBitmap(numbar[10], 60, 176, null);

			} else {
				canvas.drawBitmap(numbar[bms.MISS % 10000 / 1000], 60, 176,
						null);
				temp_flag = false;
			}
			if (bms.MISS % 1000 / 100 == 0 && temp_flag) {
				canvas.drawBitmap(numbar[10], 68, 176, null);
			} else {
				canvas.drawBitmap(numbar[bms.MISS % 1000 / 100], 68, 176,
						null);
				temp_flag = false;
			}
			if (bms.MISS % 100 / 10 == 0 && temp_flag) {
				canvas.drawBitmap(numbar[10], 76, 176, null);
			} else {
				canvas.drawBitmap(numbar[bms.MISS % 100 / 10], 76, 176, null);
				temp_flag = false;
			}
			canvas.drawBitmap(numbar[bms.MISS % 10], 84, 176, null);
		} else {
			canvas.drawBitmap(numbar[10], 60, 176, null);
			canvas.drawBitmap(numbar[10], 68, 176, null);
			canvas.drawBitmap(numbar[10], 76, 176, null);
			canvas.drawBitmap(numbar[10], 84, 176, null);
		}
		// クリアーの描写
		canvas.drawBitmap(clear[bms.CLEAR], 13, 185, null);
		// DJlevelの描写
		if (bms.HIGHTSCORE != 0 && bms.Max_Noat != 0) {
			int DJL = (int) (bms.HIGHTSCORE * 100 / (bms.Max_Noat*2) / (100/9));
			switch (DJL) {
			case 9:
			case 8:
				canvas.drawBitmap(ABCD[0], 94, 170, null);
				canvas.drawBitmap(ABCD[0], 109, 170, null);
				canvas.drawBitmap(ABCD[0], 124, 170, null);
				break;
			case 7:
				canvas.drawBitmap(ABCD[0], 101, 170, null);
				canvas.drawBitmap(ABCD[0], 118, 170, null);
				break;
			case 6:
				canvas.drawBitmap(ABCD[0], 109, 170, null);
				break;
			case 5:
				canvas.drawBitmap(ABCD[1], 109, 170, null);
				break;
			case 4:
				canvas.drawBitmap(ABCD[2], 109, 170, null);
				break;
			case 3:
				canvas.drawBitmap(ABCD[3], 109, 170, null);
				break;
			case 2:
				canvas.drawBitmap(ABCD[4], 109, 170, null);
				break;
			case 1:
			case 0:	
				canvas.drawBitmap(ABCD[5], 109, 170, null);
				break;
			}
		}
		paint.setColor(Color.WHITE);
		paint.setTextAlign(Paint.Align.RIGHT);
		paint.setTextSize(28);
		canvas.drawText(bms.TITLE, 320, 45, paint);
		paint.setTextSize(16);
		canvas.drawText(bms.SUBTITLE, 320, 55, paint);
		canvas.drawText(bms.ARTIST, 320, 75, paint);
		canvas.drawText(bms.GENRE, 320, 20, paint);
		canvas.drawText("BPM " + (int)bms.BPM, 320, 95, paint);
		holder.unlockCanvasAndPost(canvas);
	}

	public void set_Read_HEADERFile(Read_HEADERFile bms) {
		this.bms = bms;
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO 自動生成されたメソッド・スタブ

	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		draw();

	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO 自動生成されたメソッド・スタブ

	}
}
