package aokai.app.BMSPayer;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.preference.EditTextPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.Preference.OnPreferenceChangeListener;

public class Preferences extends PreferenceActivity {

	// テキストボックスPreferenceの PreferenceChangeリスナー
	private OnPreferenceChangeListener editTextPreference_OnPreferenceChangeListener = new OnPreferenceChangeListener() {
		@Override
		public boolean onPreferenceChange(Preference preference, Object newValue) {
			String input = newValue.toString();
			if (input != null) {
				// nullでなく100以上であれば要約を変更する
				preference.setSummary(input + "ms");
				return true;
			} else {
				// nullまたは100以下はエラー
				return false;
			}
		}
	};

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		addPreferencesFromResource(R.xml.preferences);

		// キーを基に、テキストボックス設定のインスタンスを取得する
		EditTextPreference etp = (EditTextPreference) findPreference("showtime_preference");
		// リスナーを設定する
		etp.setOnPreferenceChangeListener(editTextPreference_OnPreferenceChangeListener);

		// キーを基に、テキストボックス設定のインスタンスを取得する
		EditTextPreference etp3 = (EditTextPreference) findPreference("stoptime_preference");
		// リスナーを設定する
		etp3.setOnPreferenceChangeListener(editTextPreference_OnPreferenceChangeListener);

		// キーを基に、テキストボックス設定のインスタンスを取得する
		EditTextPreference etp2 = (EditTextPreference) findPreference("leanpostion_preference");
		// リスナーを設定する
		etp2.setOnPreferenceChangeListener(editTextPreference_OnPreferenceChangeListener);
		
		Preference ddb = (Preference) findPreference("deleatDB");
		ddb.setOnPreferenceClickListener(new Preference.OnPreferenceClickListener() {			
			@Override
			public boolean onPreferenceClick(Preference preference) {
				
				AlertDialog.Builder builder = new AlertDialog.Builder(Preferences.this);
				builder.setMessage("本当に削除しますか?")
				       .setCancelable(false)
				       .setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
								AlertDialog.Builder builder = new AlertDialog.Builder(Preferences.this);
								builder.setMessage("本当の本当に削除しますか?")
								       .setCancelable(false)
								       .setPositiveButton("Yes", new DialogInterface.OnClickListener() {
								           public void onClick(DialogInterface dialog, int id) {
								        		DatabaseOpenHelper dbHelpar;
								        		SQLiteDatabase db;
								        		// データーベースオブジェクトの取得
								        		dbHelpar = new DatabaseOpenHelper(Preferences.this);
								        		db = dbHelpar.getWritableDatabase();
								        		dbHelpar.AllDelete(db);
								           }
								       })
								       .setNegativeButton("No", new DialogInterface.OnClickListener() {
								           public void onClick(DialogInterface dialog, int id) {
								                dialog.cancel();
								           }
								       });
								AlertDialog alert = builder.create();
								alert.show();
				           }
				       })
				       .setNegativeButton("No", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
				                dialog.cancel();
				           }
				       });
				AlertDialog alert = builder.create();
				alert.show();
				return false;
			}
		});
		Preference version = (Preference) findPreference("version");
		version.setOnPreferenceClickListener(new Preference.OnPreferenceClickListener() {			
			@Override
			public boolean onPreferenceClick(Preference preference) {
				
				AlertDialog.Builder builder = new AlertDialog.Builder(Preferences.this);
				builder.setTitle("匠について");
				builder.setMessage("ver0.0008\n私です\n\nSpecial Thanks!!\nIcon:らっしー様")
				       .setCancelable(false)
				       .setPositiveButton("OK", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
				           }
				       });
				AlertDialog alert = builder.create();
				alert.show();
				return false;
			}
		});
	}
}
