package aokai.app.BMSPayer;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Read_BMSFile extends Read_HEADERFile {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/*
	 * 00 小節頭での10進数&浮動少数BPM変更 永久欠番チャンネル Removed /*01 BGM /*02 小節長変更 /*03 BPM変更
	 * /*04 BGA /*05 Extended Object (BM98 固有命令) /*06 Poor BGA
	 * /*07BGAレイヤ(BM98K拡張) /*08 拡張BPM (bemaniaDX 拡張) /*09 ストップシーケンス (Delight
	 * Delight Reduplication 拡張) /*0A BGAレイヤ2 (ナナシグルーヴ拡張) /*0B BGA透明度
	 * (ナナシグルーヴ拡張) /*0C BGAレイヤ透明度 (ナナシグルーヴ拡張) /*0D BGAレイヤー2透明度 (ナナシグルーヴ拡張) /*0E
	 * POOR画像透明度(ナナシグルーヴ拡張) /*10 予約チャンネル /*11 1P側可視オブジェ (1キー:白鍵左) /*12
	 * 1P側可視オブジェ(2キー:黒鍵左) /*13 1P側可視オブジェ (3キー:白鍵中) /*14 1P側可視オブジェ (4キー:黒鍵右) /*15
	 * 1P側可視オブジェ (5キー:白鍵右) /*16 1P側可視オブジェ (スクラッチ or 8キー(PMS)) /*17
	 * 1P側可視オブジェ(スクラッチフリーゾーン(BM98) or フットペダル(ナナシグルーヴ) or 9キー(PMS)) /*18
	 * 1P側可視オブジェ(6キー)(Flash Terminal拡張) /*19 1P側可視オブジェ (7キー)(Flash Terminal拡張)
	 * /*******************************************
	 */

	public String music_File;
	public List<Long> chkey_S = new ArrayList<Long>();
	public List<Long> chkey01 = new ArrayList<Long>();
	public List<Long> chkey02 = new ArrayList<Long>();
	public List<Long> chkey03 = new ArrayList<Long>();
	public List<Long> chkey04 = new ArrayList<Long>();
	public List<Long> chkey05 = new ArrayList<Long>();
	public List<Long> chkey06 = new ArrayList<Long>();
	public List<Long> chkey07 = new ArrayList<Long>();
	public List<Long> chBar = new ArrayList<Long>();


	private int BMS_Start_time;// BGMをスタートさせる時間…後々すべての要素から引くべきだじょ
	private int ch;// チャンネルを一時的に保存
	private int now_Bar;// 現在の小節番号
	private int temp_Bar;// 現在の小節番号を一時的に保存する場所…たぶん？処理を早くするために
	private double now_time;// 現在の小節番号先頭時間
	private long time_length;// 1小節の長さ
	private int line_length;

	public Read_BMSFile() {
		BMS_Start_time = 0;
		now_Bar = 0;
		now_time = 0;// now_timeに0を代入ッ！！
		time_length = 0;

		chBar.add((long) now_time);
	}

	// bmsファイルのヘッダを読む
	public void Read(String path, String file_name) {
		String line = "";
		file_path = path;
		this.file_name = file_name;
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(
					new FileInputStream(path + "/" + file_name), "Shift_JIS"));
			if (file_name.indexOf(".bms") != -1) {
				File_Format = 1;
			}
			if (file_name.indexOf(".bme") != -1) {
				File_Format = 2;
			}
			if (file_name.indexOf(".bml") != -1) {
				File_Format = 3;
			}
			while ((line = br.readLine()) != null) {
				read_line(line);
			}
		} catch (IOException e) {
			System.out.println(e);
		}
	}

	@Override
	public Boolean read_line(String line) {
		Boolean boo;
		if ((boo = super.read_line(line)) == true) {
			return boo;
		}
		if (read_type == 1) {
			if (line.indexOf("#WAV") != -1) {
				music_File = line.substring(7, line.length());
				return true;
			}
		}
		/****** ☆彡私が馬鹿なため小節数は順番にならんでいると考えてプログラムを組むとする☆彡あはっ！ ******/
		if (read_type == 2) {
			if (line.indexOf("#") != -1) {
				ch = Integer.parseInt(line.substring(4, 6));
				temp_Bar = Integer.parseInt(line.substring(1, 4));
				if (temp_Bar != now_Bar) {
					while (temp_Bar > now_Bar) {
						now_time += time_length;
						chBar.add((long) now_time);
						time_length = (long) (240000 / BPM);
						now_Bar++;
					}
				}
				/* 01 BGM #aaabb:cccc */
				if (ch == 01) {
					if (BMS_Start_time == 0) {
						line_length = (line.length() - 7);
						for (int i = 0; i < line_length; i += 2) {
							if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
								BMS_Start_time = (int) (time_length * i
										/ line_length + now_time);
							}
						}
						return true;
					}
				}
				/* 02 小節長変更 */
				if (ch == 02) {
					time_length = (long) (time_length * Float.parseFloat(line
							.substring(7, line.length())));
				}
				/* 03 BPM変更 */
				if (ch == 03) {
					time_length = (long) (time_length * BPM / (Integer
							.parseInt(line.substring(7, line.length()), 16)));
					BPM = Integer
							.parseInt(line.substring(7, line.length()), 16);
				}
				/* 11 1P側可視オブジェ (1キー:白鍵左) */
				if (ch == 11) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey01.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 12) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey02.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 13) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey03.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 14) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey04.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 15) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey05.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 16) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey_S.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 18) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey06.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
				if (ch == 19) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i)) != 00) {
							chkey07.add((long) (time_length * i / line_length + now_time));
						}
					}
					return true;
				}
			}
		}
		if (line.indexOf("MAIN DATA") != -1) {
			if (LNOBJ == false) {
				read_type = 2;
				time_length = (long) (240000 / BPM);
				return true;
			}
		}
		return false;
	}

	public Lite_BMSFile make_Lite_BMSFile() {
		int i;
		Lite_BMSFile L_bms = new Lite_BMSFile();
		L_bms.file_path = file_path;
		L_bms.file_name = file_name;
		L_bms.music_File = music_File;
		int max_size = chkey01.size();
		if (max_size < chkey02.size())
			max_size = chkey02.size();
		if (max_size < chkey03.size())
			max_size = chkey03.size();
		if (max_size < chkey04.size())
			max_size = chkey04.size();
		if (max_size < chkey05.size())
			max_size = chkey05.size();
		if (max_size < chkey06.size())
			max_size = chkey06.size();
		if (max_size < chkey07.size())
			max_size = chkey07.size();
		if (max_size < chkey_S.size())
			max_size = chkey_S.size();
		if (max_size < chBar.size())
			max_size = chBar.size();

		L_bms.chkey = new long[9][max_size + 4];
		for (i = 0; i < chkey01.size(); i++) {
			L_bms.chkey[1][i] = chkey01.get(i) - BMS_Start_time;
		}
		L_bms.chkey[1][i] = 999999;

		for (i = 0; i < chkey02.size(); i++) {
			L_bms.chkey[2][i] = chkey02.get(i) - BMS_Start_time;
		}
		L_bms.chkey[2][i] = 999999;

		for (i = 0; i < chkey03.size(); i++) {
			L_bms.chkey[3][i] = chkey03.get(i) - BMS_Start_time;
		}
		L_bms.chkey[3][i] = 999999;

		for (i = 0; i < chkey04.size(); i++) {
			L_bms.chkey[4][i] = chkey04.get(i) - BMS_Start_time;
		}
		L_bms.chkey[4][i] = 999999;

		for (i = 0; i < chkey05.size(); i++) {
			L_bms.chkey[5][i] = chkey05.get(i) - BMS_Start_time;
		}
		L_bms.chkey[5][i] = 999999;

		for (i = 0; i < chkey06.size(); i++) {
			L_bms.chkey[6][i] = chkey06.get(i) - BMS_Start_time;
		}
		L_bms.chkey[6][i] = 999999;

		for (i = 0; i < chkey07.size(); i++) {
			L_bms.chkey[7][i] = chkey07.get(i) - BMS_Start_time;
		}
		L_bms.chkey[7][i] = 999999;

		for (i = 0; i < chkey_S.size(); i++) {
			L_bms.chkey[0][i] = chkey_S.get(i) - BMS_Start_time;
		}
		L_bms.chkey[0][i] = 999999;

		for (i = 0; i < chBar.size(); i++) {
			L_bms.chkey[8][i] = chBar.get(i) - BMS_Start_time;
		}
		L_bms.chkey[8][i] = (long) (L_bms.chkey[8][i - 1] + 240000 / BPM);
		L_bms.chkey[8][i + 1] = (long) (L_bms.chkey[8][i] + 240000 / BPM);
		L_bms.chkey[8][i + 2] = 999999;

		L_bms.Max_noat = Max_Noat;
		if (TOTAL == -1) {
			L_bms.TOTAL = Max_Noat + 200;
		} else {
			L_bms.TOTAL = TOTAL;
		}
		L_bms.TITLE = TITLE;
		return L_bms;
	}
}
