package aokai.app.BMSPayer;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Serializable;

import android.graphics.Color;
import android.util.Log;

public class Read_HEADERFile implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public String file_path;
	public String file_name;
	/*
	 * read_tyle = 0...読み込まない read_type = 1...ヘッタ読み込み read_type = 2...LNOBJ =
	 * falseでメイン読み込み
	 */
	public int read_type = 0;
	/*
	 * File_Format = 0...未定 File_Format = 1...bms File_Format = 2...bme
	 * File_Format = 3...bml
	 */
	public int File_Format = 0;
	public int PLAYER;
	public String GENRE;/* 曲のジャンルを定義します。 */
	public String TITLE;/* 曲のタイトルを定義します */
	public String SUBTITLE;/* 曲のサブタイトルを定義します */
	public String ARTIST;/* 作曲者を定義します */
	public float BPM;/* 曲のテンポを定義します */
	public int PLAYLEVEL;/* 難易度を定義します */
	public Boolean STAGEFILE;
	public int HIGHTSCORE = 0;
	/*
	 * 定義するとそのBMSはMGQ形式のロングノートを使用した譜面として認識されます。
	 * 未使用時省略。省略時、ch5x、6xの指定は全てRDMタイプ1形式のロングノートと認識されます。
	 * MGQ形式のロングノートは00以外が連続している場合につながり、00が出現した時点で切れます。
	 * 前の小節の最後が00でなく、小節の最初が00でない場合には、小節をまたがってつながります。
	 */
	public Boolean LNTYPE;
	/*
	 * 定義するとそのBMSはRDMタイプ2形式のロングノートを使用した譜面として認識されます。
	 * また、ロングノートの終端として使用するオブジェを#WAVで指定した番号で指定します。 #LNOBJの命令に指定されたノートが発見された場合には、
	 * その前ノートから指定されたノートまでロングノートで処理されます。
	 * また、#LNOBJに指定されたオブジェクトのWAVは、通過時にはBGMとして再生されます。
	 * 未対応のBMSプレーヤで意図しないノート構成になる危険を避けるため、 ファイルの拡張子を.bmlに変更することが推奨されています。 ex.
	 * #LNOBJ AA // オブジェAAをロングノートの終端に使用する
	 */
	public Boolean LNOBJ;
	/* 判定ランクを指定。x=0でvery hard,1でhard,2でnormal,3でeasy */
	public int RANK;
	/* ゲージの増量設定(浮動小数点表記)省略時200+オブジェ数 */
	public float TOTAL;
	public int Max_Noat;
	public int DIFFICULTY;
	public int CLEAR;
	public int MISS;
	public int MAXCOMBO;

	public Read_HEADERFile() {
		file_path = "";
		file_name = "";
		PLAYER = 1;
		GENRE = "";
		TITLE = "";
		SUBTITLE = "";
		ARTIST = "";
		BPM = 130;
		PLAYLEVEL = 3;
		LNTYPE = false;
		LNOBJ = false;
		RANK = 3;
		TOTAL = -1;
		DIFFICULTY = 2;
		STAGEFILE = false;
		Max_Noat = 0;
		CLEAR = 0;
		MISS = -1;
		MAXCOMBO = 0;
	}

	public int difficultColor() {
		switch (DIFFICULTY) {
		case 2:
			return Color.rgb(0, 162, 232);
		case 3:
			return Color.rgb(255, 215, 74);
		case 4:
			return Color.rgb(255, 0, 0);
		case 5:
			return Color.rgb(136, 0, 0);
		}
		return 0;
	}

	// bmsファイルのヘッダを読む
	public void Read_header(String path, String file_names) {
		String line = "";
		file_path = path;
		file_name = file_names;
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(
					new FileInputStream(path + "/" + file_names), "Shift_JIS"));
			if (file_names.indexOf(".bms") != -1) {
				File_Format = 1;
			}
			if (file_names.indexOf(".bme") != -1) {
				File_Format = 2;
			}
			if (file_names.indexOf(".bml") != -1) {
				File_Format = 3;
			}
			while ((line = br.readLine()) != null) {
				read_line(line);
			}
		} catch (IOException e) {
			System.out.println(e);
		}
	}

	public Boolean read_line(String line) {
		int ch;
		int line_length;
		if (read_type == 1) {
			if (line.indexOf("#PLAYER") != -1) {
				PLAYER = Integer.parseInt(line.substring(8, line.length()));
				return true;
			}
			if (line.indexOf("#GENRE") != -1) {
				GENRE = line.substring(7, line.length());
				return true;
			}
			if (line.indexOf("#TITLE") != -1) {
				int num;
				if ((num = line.indexOf("-")) != -1
						|| (num = line.indexOf("～")) != -1
						|| (num = line.indexOf("(")) != -1
						|| (num = line.indexOf("（")) != -1
						|| (num = line.indexOf("［")) != -1
						|| (num = line.indexOf("<")) != -1
						|| (num = line.indexOf("「")) != -1) {
					TITLE = line.substring(7, num);
					SUBTITLE = line.substring(num, line.length());
					return true;
				} else {
					TITLE = line.substring(7, line.length());
					return true;
				}
			}
			if (line.indexOf("#SUBTITLE") != -1) {
				SUBTITLE = line.substring(10, line.length());
				return true;
			}
			if (line.indexOf("#ARTIST") != -1) {
				ARTIST = line.substring(8, line.length());
				return true;
			}
			if (line.indexOf("#BPM") != -1) {
				try {
					BPM = Integer.parseInt(line.substring(5, line.length()));
				} catch (NumberFormatException e) {
					System.out.println(e);
				}
				return true;
			}
			if (line.indexOf("#PLAYLEVEL") != -1) {
				PLAYLEVEL = Integer.parseInt(line.substring(11, line.length()));
				return true;
			}
			if (line.indexOf("#LNTYPE") != -1) {
				LNTYPE = true;
				return true;
			}
			if (line.indexOf("#LNOBJ") != -1) {
				// TODO　このあとに番号がくるからそこを修正すべし☆彡
				LNOBJ = true;
				return true;
			}
			if (line.indexOf("#RANK") != -1) {
				RANK = Integer.parseInt(line.substring(6, line.length()));
				return true;
			}
			if (line.indexOf("#TOTAL") != -1) {
				TOTAL = Float.parseFloat(line.substring(7, line.length()));
				return true;
			}
			if (line.indexOf("#DIFFICULTY") != -1) {
				DIFFICULTY = Integer
						.parseInt(line.substring(12, line.length()));
				return true;
			}
			if (line.indexOf("#STAGEFILE") != -1) {
				STAGEFILE = true;
				return true;
			}
		}
		if (read_type == 2) {
			if (line.indexOf("#") != -1) {
				ch = Integer.parseInt(line.substring(4, 6));
				if (ch == 11 || ch == 12 || ch == 13 || ch == 14 || ch == 15
						|| ch == 16 || ch == 18 || ch == 19) {
					line_length = (line.length() - 7);
					for (int i = 0; i < line_length; i += 2) {
						if (Integer.parseInt(line.substring(7 + i, 9 + i), 16) != Integer
								.parseInt("00", 16)) {
							Max_Noat++;
						}
					}
					return false;
				}
			}
		}
		if (line.indexOf("MAIN DATA") != -1) {
			if (LNOBJ == false) {
				read_type = 2;
				return false;
			}
		}
		if (line.indexOf("HEADER") != -1) {
			read_type = 1;
			return true;
		}
		return false;
	}
}
